CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  BUFFER_2K     = $800
  
  CR            = $0D
  LF            = $0A
  RESET_PIN     = 4 '26
  SOCKETS       = 4
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

  DHCP_ATTEMPTS = 10

  USB_Rx          = 31
  USB_Tx          = 30
  
  { DHCP Lease Counter }
  CNT_PIN         = 7
  NCO_FREQ        = 610         '($8000)(80x10^6)/2^32 = 610.3516Hz                           
  FREQ_610        = $8000       ' AN001-P8X32ACounters-v2.0_2.pdf (page 6)

  DHCP_SOCKET     = 3
  listenPort      = 5000

   'Prop to Prop Comms
  P2PRx         = 24
  P2PTx         = 25            ' Connections to the other Prop. Remember that TX here goes to RX there, and vice/versa  
  P2PBaud       = 19200
 'Door Position Switch Patterns
  UP = %01
  DOWN = %10
    
VAR
  long  seed

  long dataStack[20]

  long  lightVal, doorState, switchVal, rawVal
  byte  month, day, year, hour, minute, second
  long globalC, globalH

DAT
  index byte  "HTTP/1.1 200 OK", CR, LF, {
}             "Content-Type: text/html", CR, LF, CR, LF, {
}             "<HTML>", {
}             "<HEAD>", {
}             "<TITLE>Willoughby Farm</TITLE>", {
}             "</HEAD>",  {
}             "<SCRIPT LANGUAGE='JavaScript'>",CR,{
}             "Temp3 = 60",CR,  {
}             "function Counter() {",CR, {
}             "         Temp3 = Temp3 - 1;",CR, {
}             "         document.frm1.seconds.value=Temp3;",CR,{
}             "         timerID = setTimeout('Counter()',1000);",CR,{
}             "         timedRefresh()",CR, {
}             "         }",CR, {
}             "</SCRIPT>",CR, {
}             "<SCRIPT LANGUAGE='JavaScript'>",CR,{
}             "function timedRefresh() {",CR,{
}             "         setTimeout('location.reload(true);',60000);",CR,{
}             "         }",CR, {
}             "</SCRIPT>"
 
        byte  "<BODY Onload='Counter()'>"
        byte  "<center>"
        byte  "<FONT FACE=BOOKMAN OLD STYLE SIZE=8><BR>"
        byte  "Doc's Flock<BR></FONT>"
        byte  "<FONT FACE=BOOKMAN OLD STYLE SIZE=4><BR>"
        byte  "Coop Status Page  "
        byte  "(...a work in progress!)</FONT>"
        byte  "<BR><img src=http://www.tegacayanimalhospital.com/images/spinneret/coop.jpg><BR>"

        byte  "<div>"
        byte  "<FONT FACE=BOOKMAN OLD STYLE SIZE=2>Coop Date and Time: " 
time1   byte  "00/" '<--- This is a place holder ; number is dynamically updated
time2   byte  "00/20" '<--- This is a place holder ; number is dynamically updated
time3   byte  "   "'<--- This is a place holder ; number is dynamically updated
time4   byte  "  :" '<--- This is a place holder ; number is dynamically updated
time5   byte  "  :" '<--- This is a place holder ; number is dynamically updated
time6   byte  "  <BR>" '<--- This is a place holder ; number is dynamically updated
        byte  "</FONT>"
        byte  "<BR><B><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Conditions inside Coop:</FONT></B> "
        byte  "<table><tr><td>" 'wrapper table
        byte  "<table border='1'>"
        byte  "<tr><td><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Temp:</td> "
        byte  "<td><FONT FACE=BOOKMAN OLD STYLE SIZE=4 COLOR=RED>"
temp    byte  "      F "'<--- This is a place holder ; number is dynamically updated
        byte  "</FONT></FONT></td></tr>"
        byte  "<tr><td><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Humidity: </td>   "
        byte  "<td><FONT FACE=BOOKMAN OLD STYLE SIZE=4 COLOR=RED>"
humi    byte  "       % "'<--- This is a place holder ; number is dynamically updated
        byte  "</FONT></FONT></td></tr></table></td>"
        byte  "<td><table border='1'>"
        byte  "<tr><td><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Current Light:</td> "
        byte  "<td><FONT FACE=BOOKMAN OLD STYLE SIZE=4 COLOR=RED>"
num1    byte  "0000 " '<--- This is a place holder ; number is dynamically updated
        byte  "</FONT></FONT></td></tr>"
        byte  "<tr><td><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Average Light:</td> "
        byte  "<td><FONT FACE=BOOKMAN OLD STYLE SIZE=4 COLOR=RED>"
num2    byte  "0000 "'<--- This is a place holder ; number is dynamically updated
        byte  "</FONT></FONT></td></tr></table></td>"
        byte  "<td><table border='1'>"
        byte  "<tr><td><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Door Position</td>"
        byte  "<td><FONT FACE=BOOKMAN OLD STYLE SIZE=4 COLOR=RED>"
str1    byte  "      "'<--- This is a place holder ; val is dynamically updated
        byte  "</FONT></FONT></td></tr>"
        byte  "<tr><td><FONT FACE=BOOKMAN OLD STYLE SIZE=4>Switch Position</td>"
        byte  "<td><FONT FACE=BOOKMAN OLD STYLE SIZE=4 COLOR=RED>"
str2    byte  "      " '<--- This is a place holder ; val is dynamically updated
        byte  "</FONT></FONT></td></tr></table>"
        byte  "</td></tr></table>"
        byte  "</div>"
        
        byte  "<FONT FACE=BOOKMAN OLD STYLE SIZE=2><BR>"
        byte  "<FORM NAME='frm1'>"
        byte  "Seconds Until Refresh ="
        byte  "<INPUT NAME='seconds' SIZE=4 VALUE=''>"
        byte  "</FORM>" 
        byte  "</FONT>"
        byte  "</FONT>"
        byte  "</center>"
        byte  "</BODY>"
        byte  "</HTML>"
        byte  0



  buff          byte  $0[BUFFER_2K] 
  resPtr        long $0[25]
  null          long  $00
  dhcpLease     long  $ff_ff_ff
  dns_addr      byte $61, $0A, $0B, $01
  
OBJ
  pst             : "Parallax Serial Terminal"
  wiz             : "W5100.spin" 
  sock[SOCKETS]   : "Socket.spin"
  dhcp            : "Dhcp"

  STR           : "STREngine"
  P2PCOM        : "Full-Duplex_COMEngine"                         ' P2P Comm object
  SN            : "Simple_Numbers"
  fp            : "FloatString"
  f             : "Float32"

 
PUB Main | i, page, dnsServer

  i := 0
  
  pst.Start(115_200)
  pause(500)


  
  pst.str(string("Initialize W5100", CR))

  'wiz.QS_Init
  wiz.HardReset(WIZ#WIZ_RESET)
  wiz.Start(WIZ#SPI_CS, WIZ#SPI_SCK, WIZ#SPI_MOSI, WIZ#SPI_MISO)

  wiz.HardReset(RESET_PIN)

{ =======================  select deployed or test spinneret ============================== }
'deployed spinneret
'  wiz.SetMac($00, $08, $DC, $16, $F3, $25)
'  wiz.SetIp($61, $0A, $0B, $FE)                 'deployed unit
                                                 '97.10.11.254
'test spinneret
'  wiz.SetMac($00, $08, $DC, $16, $F2, $1A)     'test unit 1
  wiz.SetMac($00, $08, $DC, $16, $F2, $F4)     'test unit 2 (bad W5100)
  wiz.SetIp($61, $0A, $0B, $FD)                '97.10.11.253       
'dont forget to adjust GetValues Method 
'common to both units
  wiz.SetGateway($61, $0A, $0B, $01)          
  wiz.SetSubnetMask($FF, $FF, $FF, $00)
  wiz.CopyDNS(@dns_addr, 4)
{===========================================================================================}
  

  P2PCOM.COMEngineStart(P2PRx, P2PTx, P2PBaud)          ' Start prop to Prop comms      
  f.start                                               ' start floating point object

  cognew(GetDataValues, @dataStack)



  pst.str(string("Getting network paramters", CR))
{  dhcp.Init(@buff, DHCP_SOCKET)
  pst.str(string("Requesting IP....."))

  repeat until dhcp.DoDhcp(false)
    if(++i > DHCP_ATTEMPTS)
      quit

  if(dhcp.GetErrorCode > 0 OR i > DHCP_ATTEMPTS)
    pst.char(CR) 
    pst.str(string(CR, "DHCP Attempts: "))
    pst.dec(i)
    pst.str(string(CR, "Error Code: "))
    pst.dec(dhcp.GetErrorCode)
    pst.char(CR)
    pst.str(dhcp.GetErrorMessage)
    pst.char(CR)
    return
    
  else}
    PrintIp(wiz.GetIp)
    'Setup a 610 Hz square wave on pin 7
    {
    ctrb := %00100_000 << 23 + 1 << 9 + CNT_PIN 
    frqb := FREQ_610 
    dira[CNT_PIN] := 1
     
    'Positive edge counter on pin 7
    ctra := %01010 << 26 + CNT_PIN
    frqa := 1
    }
  pst.str(string("DNS..............."))
  dnsServer := wiz.GetDns
  PrintIp(wiz.GetDns)

  pst.str(string("DHCP Server......."))
  printIp(dhcp.GetDhcpServer)

  pst.str(string("Router IP........."))
  printIp(dhcp.GetRouter)
  pst.char(CR)

  repeat
    pst.str(string("Initialize Sockets",CR))
    repeat i from 0 to SOCKETS-1
      sock[i].Init(i, TCP, listenPort)
           
    OpenListeners
    StartListners
    
    pst.str(string("Start Socket server",CR))
    \MultiSocketServer
    pst.str(string("I blew up!"))
    pause(5000)


  
PUB OpenListeners | i
  pst.str(string("Open",CR))
  repeat i from 0 to SOCKETS-1  
    sock[i].Open
      
PUB StartListners | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].Listen)
      pst.str(string("Listen "))
    else
      pst.str(string("Listener failed ",CR))
    pst.dec(i)
    pst.char(CR)

PUB CloseWait | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].IsCloseWait) 
      sock[i].Disconnect
      sock[i].Close
      
    if(sock[i].IsClosed)  
      sock[i].Open
      sock[i].Listen

PUB MultiSocketServer | bytesToRead, i, page, j, x , bytesSent, ptr
  bytesToRead := bytesSent := i := j := x := 0
  repeat
    {
    if(dhcpLease - phsa/NCO_FREQ <  dhcpLease-10)
      pst.str(string(CR, "Renew DHCP Lease", CR))
      pst.str(string("Requesting IP....."))
      if(dhcp.DoDhcp(false))
        PrintIp(dhcp.GetIp)
        dhcpLease := dhcp.GetLeaseTime
        phsa := 1
        pause(1500)
    }
    pst.str(string(CR, "TCP Service", CR))
    CloseWait

    {
    repeat j from 0 to SOCKETS-1
      pst.str(string("Socket "))
      pst.dec(j)
      pst.str(string(" = "))
      pst.hex(wiz.GetSocketStatus(j), 2)
      pst.char(13)
    } 
    repeat until sock[i].Connected
      i := ++i // SOCKETS
    {
    pst.str(string("Connected Socket "))
    pst.dec(i)
    pst.char(CR)
    }
    'Data in the buffer?
    repeat until bytesToRead := sock[i].Available
    
    'Check for a timeout
    if(bytesToRead < 0)
      pst.str(string("Timeout",CR))
      sock[i].Disconnect
      sock[i].Open
      sock[i].Listen
      bytesToRead~
      next

    'pst.str(string("Copy Rx Data",CR))
  
    'Get the Rx buffer  
    sock[i].Receive(@buff, bytesToRead)

    {{ Process the Rx data}}
    {
    pst.char(CR)
    pst.str(string("Request:",CR))
    pst.str(@buff)
    }
    pst.str(string("Send Response",CR))
    page :=  ParseResource(@buff)
    
    'pst.str(page)
    'pst.char(CR)
    pst.str(string("Byte to send "))
    pst.dec(strsize(page))
    pst.char(CR)

    bytesSent := 0
    ptr := page
    repeat until bytesSent == strsize(page)
      bytesSent += sock[i].Send(ptr, strsize(ptr))
      ptr := page + bytesSent

    pst.str(string("Bytes Sent "))
    pst.dec(bytesSent)
    pst.char(CR)
    {
    pst.str(string("Disconnect socket "))
    pst.dec(i)
    pst.char(CR)
    }
    if(sock[i].Disconnect)
      pst.str(string("Disconnected", CR))
    else
      pst.str(string("Force Close", CR))
    sock[i].Open
    sock[i].Listen
    sock[i].SetSocketIR($FF)
    
    i := ++i // SOCKETS
    bytesToRead~

PUB ParseResource(header) | ptr, value, i, done, j
  ptr := header
  i := 0
  done := false

  repeat until IsEndOfLine(byte[ptr])
    if(IsToken(byte[ptr]))
      byte[ptr] := 0
      resPtr[i++] := ++ptr
    else
      ++ptr

    if(ptr - header > 500)
      pst.str(string(CR, "+++++++++++++++[ERROR]++++++++++++++",CR))
      return @index

  resPtr[0] := header
  {
  repeat j from 0 to i-1
    pst.str(string("ID"))
    pst.dec(j)
    pst.char($20)
    pst.str(resPtr[j])
    pst.char(CR)
  }
  repeat j from 0 to i-1
    if(strcomp(resPtr[j], string("HTTP")))

      bytemove (@time1,STR.trimCharacters(STR.numberToDecimal(month, 2)),2) '<-- update in html code                 
      bytemove (@time2,STR.trimCharacters(STR.numberToDecimal(day, 2)),2) '<-- update in html code                 
      bytemove (@time3,STR.trimCharacters(STR.numberToDecimal(year, 2)),2) '<-- update in html code                 
      bytemove (@time4,STR.trimCharacters(STR.numberToDecimal(hour, 2)),2) '<-- update in html code                 
      bytemove (@time5,STR.trimCharacters(STR.numberToDecimal(minute, 2)),2) '<-- update in html code                 
      bytemove (@time6,STR.trimCharacters(STR.numberToDecimal(second, 2)),2) '<-- update in html code                 

      bytemove (@temp,((fp.FloatToFormat(fahrenheit(globalC), 5, 2))),5) '<-- update in html code
      bytemove (@humi,((fp.FloatToFormat(globalH, 5, 2))),5) '<-- update in html code
   
      
      bytemove (@num1,STR.numberToDecimal(rawVal, 4),5) '<-- update in html code                 
      bytemove (@num2,STR.numberToDecimal(lightVal, 4),5) '<-- update in html code
        case doorState
          UP :
            bytemove (@str1,(String("OPEN  ")),6)
         DOWN :
            bytemove (@str1,(String("CLOSED")),6)                            
        case switchVal
          UP :
            bytemove (@str2,(String("OPEN  ")),6)
         DOWN :
            bytemove (@str2,(String("CLOSED")),6)                            
    
      return @index
      


PUB IsToken(value)
  return lookdown(value: "/", "?", "=", " ")

PUB IsEndOfLine(value)
  return lookdown(value: CR, LF)    

      
{    
PUB ParseResource(header) | ptr, value
  ptr := header
  repeat until byte[ptr++] == $2F '/ forward slash
  if(byte[ptr] == $20) ' space
    return @index
  else
    value := GetTemp
    WriteNode(@temperature, value)
    value := GetHumidity
    WriteNode(@humidity, value) 
    return @xml
 }



PUB GetTemp
  seed := CNT 
  ?seed
  return seed & $8F + 5

PUB GetHumidity
  seed := CNT 
  ?seed
  return !seed & $7F + 1
    
PUB WriteNode(buffer, value) | t1
  t1 := value
  t1 := t1/100
  value -= t1 * 100
  byte[buffer][0] := t1 + $30

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  byte[buffer][1] := t1 + $30
  
  t1 := value
  byte[buffer][3] := t1 + $30


PUB Toggle(pin, count)
  repeat count
    dira[pin]~~
      !outa[pin]
      waitcnt(80_000_000/8 + cnt)


     
PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return

PRI GetDataValues
  repeat

'select deployed or test
'deployed
{           
      lightVal  := P2PCOM.readLong
      doorState := P2PCOM.readLong
      switchVal := P2PCOM.readLong 
      rawVal    := P2PCOM.readLong
      globalC      := P2PCOM.readLong
      globalH      := P2PCOM.readLong      
      month     := P2PCOM.readByte
      day       := P2PCOM.readByte
      year      := P2PCOM.readByte
      hour      := P2PCOM.readByte
      minute    := P2PCOM.readByte
      second    := P2PCOM.readByte
 
    waitcnt(clkfreq/2 +cnt)
 }   
'test
    'dummy values for testing
      lightVal  := 490          
      doorState := %10
      switchVal := %01 
      rawVal    := 330
      globalC      :=99
      globalH      := 77      
      month     := 1
      day       := 29
      year      := 13
      hour      := 19
      minute    := 59
      second    := 12
 

PRI fahrenheit(t)
  ' fahrenheit = (celsius * 1.8) + 32
  return f.FAdd(f.FMul(t, 1.8), 32.0)

 